/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CUSTPADR                                                 */
/* Tabela : CUSTPADR                                                          */
/*                                                                            */
/* Criao:                                                                   */
/*                                                                            */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_CUSTPADR
BEFORE INSERT OR UPDATE OR DELETE
ON CUSTPADR FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUCUSP := SYSDATE;
   END IF;
   IF UPDATING THEN
      :NEW.DTULTATUCUSP := SYSDATE;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('CUSTPADR', :OLD.CDFILIAL, 'CDFILIAL='||:OLD.CDFILIAL||';CDSERVFILI='||:OLD.CDSERVFILI||';DTREFCUSPADR='||TO_CHAR(:OLD.DTREFCUSPADR,'YYYYMMDDHH24MISS')||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE CUSTPADR MODIFY DTULTATUCUSP DEFAULT SYSDATE
/
