var Cus00300_CustosDeNaoEstocaveis_Controller = function (ZhFilterPreferences, ZhPreferences, Query, ScreenService, General, templateManager, CUSUtilities) {
	var self = this;

	this.initFilter = function(args) {
		let widget = args.owner;
		let row = {
			CDFILIAL: getLocalVar('CDFILIAL'),
			NMFILIAL: getLocalVar('CDFILIAL') + " | " + getLocalVar('NMFILIAL'),
			DTCUSTNESTO: getLocalVar('DTPROCESSA')
		};
        self.startFilter(widget, row);
	};
	
	this.filterActions = function(widget){
	     widget.currentRow.CDFILIAL = getLocalVar('CDFILIAL');
	     widget.currentRow.NMFILIAL = getLocalVar('CDFILIAL') + " | " + getLocalVar('NMFILIAL');
	     if(widget.name == 'widDuplicarCusto'){
	        widget.currentRow.MESORIGEM = getLocalVar('DTPROCESSA');
	        widget.currentRow.MESDESTINO = getLocalVar('DTPROCESSA'); 
	     }else{
	        widget.currentRow.DTMESINIC = getLocalVar('DTPROCESSA');
	        widget.currentRow.DTMESFINA = getLocalVar('DTPROCESSA');    
	     }
	};

	this.startFilter = function (widget, currentRow) {
        return ZhPreferences.getDefaultWidgetPreferences(widget.id).then(function (result) {
            if (result && result.DEFAULT_FILTER) {
                ZhPreferences.getPreferences('filter', Query.build().where('WIDGET_ID').equals(widget.id)).then(function (filters) {
                    var defaultFilter = filters.filter(function (filter) {
                        return filter.ID == result.DEFAULT_FILTER;
                    })[0];
                    var filter = {
                        ID: defaultFilter.LABEL_TO_PREFERENCE || 'EDITED',
                        FILTER_ROW: JSON.parse(defaultFilter.FILTER_ROW)
                    };

                    currentRow = filter.FILTER_ROW;
                    
                    ZhFilterPreferences.applyFilter(widget, filter).then(function () {
                        widget.appliedFilter = widget.appliedFilter || filter;
                        widget.appliedFilter.ID = result.DEFAULT_FILTER;
                        if (defaultFilter.LABEL_TO_PREFERENCE) {
                            widget._filterInfo[0].value = defaultFilter.LABEL_TO_PREFERENCE;
                        }
                    });
                });
            } else {
                if (Util.isUndefinedOrNull(currentRow) || Util.isEmptyObject(currentRow)) {
                    currentRow = buildFilterCurrentRow(widget);
                }
            }
            return ZhFilterPreferences.openFilterWidget(widget, currentRow);
        });
   
    };

    this.beforeFilter = function(args){
        let filterRow = args.e.preference.FILTER_ROW;
        
        var widget = args.owner;
        widget.dataSourceFilter = [
            {
                name: "DTPRIMDIA",
                value: moment(filterRow.DTCUSTNESTO, 'DD/MM/YYYY').startOf('month').format('DD/MM/YYYY'),
                operator: "="
            },
            {
                name: "DTULTIDIA",
                value: moment(filterRow.DTCUSTNESTO, 'DD/MM/YYYY').endOf('month').format('DD/MM/YYYY'),
                operator: "="
            },
            {
                name: "CDFILIAL",
                value: filterRow.CDFILIAL,
                operator: "="
            }
        ];
    };

    this.afterFilter = function (args){
        let widget = args.owner;
        let stripeWidget = widget.container.getWidget('widgetStripe');
        let filterRow = args.e.preference.FILTER_ROW;
        stripeWidget.currentRow = angular.copy(filterRow);
        stripeWidget.currentRow.DTCUSTNESTO = moment(filterRow.DTCUSTNESTO, 'DD/MM/YYYY').format('MM/YYYY');
        this.validateFields(widget, filterRow);
        widget.getField('NMPRODUTO1').dataSourceFilter = [
            {
                name: "CDFILIAL",
                value: filterRow.CDFILIAL,
                operator: "="
            }
        ];
    };
    
    this.validateFields = function(widget, filterRow){
        var dataFiltrada = moment(filterRow.DTCUSTNESTO,'DD/MM/YYYY');
        var dtprocessa = moment(getLocalVar('DTPROCESSA'), 'DD/MM/YYYY');
        var mesAnterior = angular.copy(dtprocessa);
        mesAnterior.subtract(1, 'months');

        if(dataFiltrada.year() == dtprocessa.year() && 
          (dataFiltrada.month() == dtprocessa.month() || dataFiltrada.month() == mesAnterior.month())) {
                widget.getField('VRREALNESTO').readOnly = false;
          }
        else {
            widget.getField('VRREALNESTO').readOnly = true;
        }

        if(dataFiltrada.year() == dtprocessa.year() && 
           dataFiltrada.month() >= dtprocessa.month()){
                widget.getField('VRPLANNESTO').readOnly = false;
                widget.getField('VRPLANNESTO').validations = {required: true};
           } 
        else{
            widget.getField('VRPLANNESTO').readOnly = true;
            widget.getField('VRPLANNESTO').validations = {};
        }
    };

    this.openWidDuplicar = function(widget){
        ScreenService.openPopup(templateManager.container.getWidget('widDuplicarCusto'));
    };

    this.saveNaoEstocaveis = function(widget){
        if(widget.isValid()){
            var filter = widget.appliedFilter.FILTER_ROW;
            widget.currentRow.CDFILIAL = filter.CDFILIAL;
            widget.currentRow.DTCUSTNESTO = filter.DTCUSTNESTO;
            widget.currentRow.VRREALNESTO = isNaN(General.valueToFloat(widget.currentRow.VRREALNESTO)) ? null : General.valueToFloat(widget.currentRow.VRREALNESTO);
            widget.currentRow.VRPLANNESTO = General.valueToFloat(widget.currentRow.VRPLANNESTO);
            widget.currentRow.RATEIO = General.valueToFloat(widget.currentRow.RATEIO);

            widget.saveRow().then(function(success){
                widget.activate();
                if (widget.currentRow.__is_new) {
                    ScreenService.goBack();
                    widget.reload();
                }else widget.view();
                
                ScreenService.notificationMessage('Salvo com sucesso.', 'success');
                if(!widget.currentRow.VRREALNESTO) widget.currentRow.VRREALNESTO = 'DOC. FISCAIS';
            },function (error) {
                var errorMessage = 'Timeout';
                if (error.data) {
                    errorMessage = error.data.error;
                }
                ScreenService.showMessage(errorMessage);
            });
        }
    };

    this.editNaoEstocaveis = function(widget){
        widget.edit();
        widget.getField('NMPRODUTO1').validations = {};
    };

    this.incluirNaoEstocaveis = function(widget){
        widget.newRow();
        widget.getField('NMPRODUTO1').validations = {required: true};
    };

    this.duplicarCusto = function(widget){
        if(widget.isValid()){
            if(this.dataValida(widget.currentRow.MESORIGEM, widget.currentRow.MESDESTINO)){
                var widPrincipal = templateManager.container.getWidget('cus00300_custos_de_nao_estocaveis');
                widget.currentRow.DTPROCESSA = getLocalVar('DTPROCESSA');
                General.callRestEngine("cus#/cus00300_custos_de_nao_estocaveis/duplicarCusto", "Row", widget.currentRow).then(function(callback){
                    var data = callback.dataset.custoOri;
                    if(data.length > 0){
                        ScreenService.notificationMessage('Custo duplicado com sucesso', 'success');
                        var filter = widPrincipal.appliedFilter.FILTER_ROW;
                        var mesFiltro = moment(filter.DTCUSTNESTO, 'DD/MM/YYYY');
                        var mesDest = moment(widget.currentRow.MESDESTINO, 'DD/MM/YYYY');
                        if(filter.CDFILIAL == widget.currentRow.CDFILIAL && mesFiltro.year() == mesDest.year() && mesFiltro.month() == mesDest.month()) widPrincipal.reload();
                    }else ScreenService.showMessage('Mês de origem não possui dados que possam ser importados.');
                
                }.bind(this)); 
            }else ScreenService.showMessage("Mês de origem deve ser menor que o mês de destino.");
        } 
    };

    this.openWidRelatorio = function(widget){
        ScreenService.openPopup(templateManager.container.getWidget('widRelatorio'));
    };

    this.validaRelatorio = function(widget){
        if(widget.isValid()){
            var dataInicial = widget.currentRow.DTMESINIC;
		    var dataFinal 	= widget.currentRow.DTMESFINA;
            if(moment(dataInicial, 'DD/MM/YYYY') <= moment(dataFinal, 'DD/MM/YYYY')){
                General.openReportPopup(widget, this.abreRelatorio, [widget.currentRow, widget.currentRow.CD_REPORT_NAME], CUSUtilities.getReportFormats());    
            }else ScreenService.showMessage("A data inicial deve ser menor ou igual a data final.");
            
        }
    };

    this.abreRelatorio = function(currentRow, reportName) {
		currentRow.DTINIC = moment(currentRow.DTMESINIC, 'DD/MM/YYYY').format('MM/YYYY');
		currentRow.DTFINA = moment(currentRow.DTMESFINA, 'DD/MM/YYYY').format('MM/YYYY');
        currentRow.NRORG = getLocalVar('NRORG');
        currentRow.CDPICTPROD = getLocalVar("CDPICTPROD").replace(/[^(/\.|\ )]/g, "@");
		General.openReport('cus_operacional#/cus00300_custos_de_nao_estocaveis/relatorio', reportName, currentRow);
	}.bind(this);
    
    this.dataValida = function (dataIni, dataFin) {
		var result = false;
		if (dataIni && dataFin && moment(dataIni, 'DD/MM/YYYY') < moment(dataFin, 'DD/MM/YYYY')) result = true;
		return result;
    };
    
    this.setProd = function(widget){
        widget.currentRow.CDPRODUTO = widget.currentRow.CDPRODUTO1;
        widget.currentRow.NMPRODUTO = widget.currentRow.NMPRODUTO1;
        widget.currentRow.CDARVPROD = widget.currentRow.CDARVPROD1;
    };

};

Configuration(function (ContextRegister) {
	ContextRegister.register('Cus00300_CustosDeNaoEstocaveis_Controller', Cus00300_CustosDeNaoEstocaveis_Controller);
});